;============================================================
; Main Map Split
; By Erik
;
; This code will allow you to split the main map between
; a "lower" and a "upper" part. Note that you can only
; split in the X axis: you can't have a "left" and "right"
; division.
; Requires UberASM.
;============================================================

;---

!split_pos      = $50           ;   must end in 0. Works similar to the separate OW songs patch.
!scroll_lock    = $0070         ;   position of the screen where scrolling with Start will stop.

;---

;   Co-processor checks
if read1($00FFD5) == $23
        sa1rom
        !dp     = $3000
        !addr   = $6000
        !bank   = $000000
else
        lorom
        !dp     = $0000
        !addr   = $0000
        !bank   = $800000
endif

;---

org $04822D
        dw !scroll_lock

org $04985A
        autoclean JSL lock

;---

freedata
lock:
        SEP #$20
        LDA $1F21|!addr
        ASL #3
        AND #$F0
        STA $0E
        LDA $1F1F|!addr
        LSR
        ORA $0E
        CMP.b #!split_pos
        LDX #$0002
        BCS .no_lock
        LDX #$0000
.no_lock
        TXY
        REP #$20
        RTL

